/*
 * Lua Commander - Utilities Functions, String and Text File Handling
 *
 * Copyright (C) 1999-2000, Antonio E. Scuri, Tecgraf/PUC-Rio.
 *
 * For all the following functions 
 * the returned string must be deallocated with free(), with some exceptions marked.
 */


#ifndef _UTL_H
#define _UTL_H

#ifdef __cplusplus
extern "C" {
#endif

/* System */

void utlWait(int time, int (*idle)(void));

/* File */

char* utlLoadTextFile(char* file_name);
int utlSaveTextFile(char* file_name, char* text);
unsigned long utlFileSize(char* file_name);

char* utlGetFilePath(char *file_name);
char* utlGetFileTitle(char *file_name);
char* utlFullPath(char* filename);
char* utlMakeFullPath(char* path, char* filename);

char* utlGetCurrentDirectory(void);
int utlSetCurrentDirectory(char* dir);

/* String */

int utlStrLines(char* text);
char* utlGetLine(char* text, int *size);  /* returns a pointer inside text */

char* utlStrDup(char* str);
char* utlStrDupUntil(char* str, char c);
char* utlStrDupSize(char* str, int size);
char* utlStrDupPlus(char* str, int size_plus);
char* utlStrCat(char* str1, char* str2);
char* utlStrUpper(char* str);
char* utlStrLower(char* str);
char* utlStr(int num_char);
char* utlStrf(char* format, ...);


#ifdef __cplusplus
}
#endif

#endif
