/*
 * Lua Commander - String Utilities Functions
 *
 * Copyright (C) 1999-2000, Antonio E. Scuri, Tecgraf/PUC-Rio.
 *
 * Tips: 
 *        malloc(strlen+1)
 *        text[strlen] = 0
 */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "utl.h"


char* utlGetLine(char* str, int *size)
{
  *size = 0;

  while(*str != 0 && *str != '\n')
  {
    if (*str != '\r')
      (*size)++;

    str++;
  }

  if (*str == 0)
    return str;
  else
    return str+1;
}

int utlStrLines(char* str)
{
  int n = 1;

  while(*str != 0)
  {
    if (*str == '\n')
      n++;

    str++;
  }

  return n;
}

char* utlStrDup(char* str)
{
  int len = strlen(str) + 1;
  char* new_str = malloc(len);
  memcpy(new_str, str, len);
  return new_str;
}

char* utlStrDupSize(char* str, int size)
{
  char* new_str;
  int str_len = strlen(str);
  if (str_len < size)
    size = str_len;
  size++;
  new_str = malloc(size);
  memcpy(new_str, str, size);
  new_str[size-1] = 0;
  return new_str;
}

char* utlStrDupUntil(char* str, char c)
{
  char* new_str, *str_ptr = str;
  int size;

  while(*str_ptr != 0 && *str_ptr != c)
    str_ptr++;

  size = str_ptr - str;
  size++;
  new_str = malloc(size);
  memcpy(new_str, str, size);
  new_str[size-1] = 0;
  return new_str;
}

char* utlStrDupPlus(char* str, int size_plus)
{
  int str_len = strlen(str);
  int len = str_len + 1 + size_plus;
  char* new_str = malloc(len);
  memcpy(new_str, str, str_len);
  return new_str;
}

char* utlStr(int num_char)
{
  char* new_str = malloc(num_char+1);
  new_str[0] = 0;
  return new_str;
}

char* utlStrf(char* format, ...)
{
  char str[65535L];
  va_list arglist;
  va_start(arglist, format);
  vsprintf(str, format, arglist);
  return utlStrDup(str);
}

char* utlStrCat(char* str1, char* str2)
{
  int len1 = strlen(str1);
  int len2 = strlen(str2);
  char* new_str = utlStr(len1+len2);
  memcpy(new_str, str1, len1);
  memcpy(new_str+len1, str2, len2);
  return new_str;
}

char* utlStrUpper(char* str)
{
  char* new_str = utlStrDup(str);

  int i = 0;
  while(str[i] != 0)
  {
    new_str[i] = toupper(str[i]);
    i++;
  }

  return new_str;
}

char* utlStrLower(char* str)
{
  char* new_str = utlStrDup(str);

  int i = 0;
  while(str[i] != 0)
  {
    new_str[i] = tolower(str[i]);
    i++;
  }

  return new_str;
}

