/*
 * Lua Commander - System Utilities Functions
 *
 * Copyright (C) 1999-2000, Antonio E. Scuri, Tecgraf/PUC-Rio.
 */


#include <stdlib.h>
#include <time.h>

#include "utl.h"


void utlWait(int time, int (*idle)(void))
{
  clock_t goal, cur;   
  time = (time * CLOCKS_PER_SEC) / 1000;
  cur = clock();
  goal = (clock_t)time + cur;
  while(goal > cur)
  {
    if (idle)
    {
      int ret = idle();
      if (ret == 1)
        return;
    }

    cur = clock();
  }
}

